vexalarm.options.profiles.current = ""
vexalarm.options.profiles.name = ""
vexalarm.options.profiles.renameName = ""

vexalarm.options.profiles.statusMsg = {
	["save"] = " ",
	["rename"] = " ",
	["load"] = " ",
	["delete"] = " "}

function vexalarm.options.profiles.feedback(category, text, isError)
	for key in pairs(vexalarm.options.profiles.statusMsg) do
		vexalarm.options.profiles.statusMsg[key] = " "
	end
	if isError then
		text = "|CFFC41F3B"..text.."|r"
	else
		text = "|CFF00FF00"..text.."|r"
	end
	
	if vexalarm.options.profiles.statusMsg[category] ~= nil then
		vexalarm.options.profiles.statusMsg[category] = text
	end
end

function vexalarm.options.profiles.save()
	local key = vexalarm.options.profiles.name
	if vexalarm.options.general.checkName(key) then
		if vexalarm_SV_profiles[key] == nil then vexalarm_SV_profiles[key] = {} end
		
		if vexalarm_SV_profiles[key]["general"] == nil then vexalarm_SV_profiles[key]["general"] = {} end
		vexalarm_SV_profiles[key]["general"] = vexalarm.lib.copyTable(vexalarm_SV_general)
		
		if vexalarm_SV_profiles[key]["frames"] == nil then vexalarm_SV_profiles[key]["frames"] = {} end
		vexalarm_SV_profiles[key]["frames"] = vexalarm.lib.copyTable(vexalarm_SV_frame)
		
		if vexalarm_SV_profiles[key]["rw"] == nil then vexalarm_SV_profiles[key]["rw"] = {} end
		vexalarm_SV_profiles[key]["rw"] = vexalarm.lib.copyTable(vexalarm_SV_rw)
		
		if vexalarm_SV_profiles[key]["spellprofiles"] == nil then vexalarm_SV_profiles[key]["spellprofiles"] = {} end
		vexalarm_SV_profiles[key]["spellprofiles"] = vexalarm.lib.copyTable(vexalarm_SV_spellprofiles)
		
		if vexalarm_SV_profiles[key]["spells"] == nil then vexalarm_SV_profiles[key]["spells"] = {} end
		vexalarm_SV_profiles[key]["spells"] = vexalarm.lib.copyTable(vexalarm_SV_spells)
		
		vexalarm.options.profiles.name = ""
		
		vexalarm.options.profiles.feedback("save", "Profile saved successfully", false)
	else
		vexalarm.options.profiles.feedback("save", "Couldn't save profil. Name is invalid.", true)
	end
end


function vexalarm.options.profiles.getList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexalarm_SV_profiles) do
		if key == vexalarm_SV_default["profile"] and default then
			returnvalue[key]=key.." (Default Profile)"
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No saved profile found"
	end
	
	return returnvalue
end

function vexalarm.options.profiles.delete()
	local key = vexalarm.options.profiles.current
	
	if vexalarm.options.general.checkName(key) then
		vexalarm_SV_profiles[key] = nil
		vexalarm.options.profiles.renameName = ""
		vexalarm.options.profiles.current = ""
		
		vexalarm.options.profiles.feedback("delete", "Profile deleted successfully", false)
	else
		vexalarm.options.profiles.feedback("delete", "Couldn't delete profile. Profilename is not valid.", true)
	end
end

function vexalarm.options.profiles.rename()
	local key = vexalarm.options.profiles.current
	local name = vexalarm.options.profiles.renameName
	
	if vexalarm.options.general.checkName(name) and vexalarm_SV_profiles[key]~=nil then
		if key ~= name then
			vexalarm_SV_profiles[name] = vexalarm.lib.copyTable(vexalarm_SV_profiles[key])
			vexalarm_SV_profiles[key] = nil
			vexalarm.options.profiles.renameName = name
			vexalarm.options.profiles.current = name
			
			vexalarm.options.profiles.feedback("rename", "Profile renamed successfully", false)
		else
			vexalarm.options.profiles.feedback("rename", "Couldn't rename profile. Reason: The new name and the old name are the same.", true)
		end
	elseif not(vexalarm.options.general.checkName(name)) then
		vexalarm.options.profiles.feedback("rename", "Couldn't rename profile. New profilename is not valid.", true)
	elseif vexalarm_SV_profiles[key]==nil then
		vexalarm.options.profiles.feedback("rename", "Couldn't rename profile. Old profile wasn't found.", true)
	end
end

function vexalarm.options.profiles.load(fragment, noreload, all)
	local key = vexalarm.options.profiles.current
	if vexalarm.options.general.checkName(key) then
		if vexalarm_SV_profiles[key] ~= nil then 
			if fragment == "all" then
				vexalarm.options.profiles.load("frames", noreload, true)
				vexalarm.options.profiles.load("rw", noreload, true)
				vexalarm.options.profiles.load("spelldata", noreload, true)
			elseif fragment == "frames" then
				vexalarm_SV_frame = vexalarm.lib.copyTable(vexalarm_SV_profiles[key]["frames"])
				vexalarm_SV_general = vexalarm.lib.copyTable(vexalarm_SV_profiles[key]["general"])
			elseif fragment == "rw" then
				vexalarm_SV_rw = vexalarm.lib.copyTable(vexalarm_SV_profiles[key]["rw"])
			elseif fragment == "spelldata" then
				for k,v in pairs (vexalarm.lib.copyTable(vexalarm_SV_profiles[key]["spellprofiles"])) do
					vexalarm_SV_spellprofiles[k] = vexalarm.lib.copyTable(v)
				end
				vexalarm_SV_spells = vexalarm.lib.copyTable(vexalarm_SV_profiles[key]["spells"])
			end
			if not(noreload) then
				vexalarm.initialize.core(true)
			end
		end
		
		local load_string = ""
		if fragment == "all" then
			load_string = "Complete profile"
		elseif not(all) and fragment == "spelldata" then
			load_string = "Spelldata"
		elseif not(all) and fragment == "data" then
			load_string = "Settings"
		elseif not(all) and fragment == "f_data" then
			load_string = "Frames"
		end
		vexalarm.options.profiles.feedback("load", load_string.." loaded successfully", false)
	else
		vexalarm.options.profiles.feedback("load", "Couldn't load profile. Profile name is invalid.", true)
	end
end