function vexalarm.options.spells.profiles.panel()	
	return {
		type = "group",
		args = {
			grpprofile= {
				name = "Spell-Profile to edit",
				order=1, type ="group", dialogInline = true,
				args = {
					profile = {
						name = "Existing spell-profiles",
						order=1, type = "select", style = "dropdown", width="double",
						values = vexalarm.options.spells.profiles.getList(true, true),
						set = function(self,key)
							vexalarm.options.spells.profiles.current = key
							vexalarm.options.spells.profiles.newName = key
							vexalarm.options.spells.profiles.name = key
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.spells.profiles.current end,
						},
					},
				},
			space1 = {name = " ", type = "description", order=2},
			grpsave = {
				name = "Save and rename",
				order=10, type ="group", dialogInline = true,
				args = {
					addName = {
						name = "Name",
						order=1, type = "input", width="double",
						set = function(info,val) vexalarm.options.spells.profiles.name=val vexalarm.options.spells.profiles.newName=val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.profiles.name end,
						},
					addButton = {
						name = "save",
						order=2, type = "execute", width="half",
						disabled = not(vexalarm.options.general.checkName(vexalarm.options.spells.profiles.name)),
						func = function(info,val) vexalarm.options.spells.profiles.save() vexalarm.initialize.core(true) end,
						confirm = vexalarm_SV_spellprofiles[vexalarm.options.spells.profiles.name]~= nil,
						confirmText = "A Spellprofile with that name allready exists. Do you want to overwrite it ?",
						},
					changename = {
						name = "rename",
						order=3, type = "execute", width="half",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.getList(), vexalarm.options.spells.profiles.current) or vexalarm.options.spells.profiles.newName=="",
						func = function(info,val) vexalarm.options.spells.profiles.rename() vexalarm.initialize.core(true) end,
						confirm = vexalarm_SV_spellprofiles[vexalarm.options.spells.profiles.newName]~= nil,
						confirmText = "A Spellprofile with the new name allready exists. Do you want to overwrite it ?",
						},
					status = {name = vexalarm.options.spells.profiles.statusMsg["save"]..vexalarm.options.spells.profiles.statusMsg["rename"], type = "description", order=4},
					},
				},
			space2 = {name = " ", type = "description", order=11},
			grpdelete = {
				name = "Load and delete",
				order=20, type ="group", dialogInline = true,
				args = {
					load_exe = {
						name = "load",
						order=3, type = "execute", --width="half",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.getList(), vexalarm.options.spells.profiles.current),
						func = function(info,val) vexalarm.options.spells.profiles.load() vexalarm.initialize.core(true) end,
						},
					delete_exe = {
						name = "delete",
						order=4, type = "execute", --width="half",
						func = function(info,val) vexalarm.options.spells.profiles.delete() vexalarm.initialize.core(true) end,
						confirm = true,
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.getList(), vexalarm.options.spells.profiles.current),
						confirmText = "Do you really want to delete this spell-profile?"
						},
					status = {name = vexalarm.options.spells.profiles.statusMsg["load"], type = "description", order=10},
					},
				},
			space3 = {name = " ", type = "description", order=21},
			grpsend = {
				name = "Send and save received spell-profiles",
				order=30, type ="group", dialogInline = true,
				args = {
					send_info = {name = "You can send spell-profiles to other players who also have the addon active", type = "description", order=1},
					send_target = {
						name = "Target player",
						order=2, type = "input", width="double",
						-- disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.getList(), vexalarm.options.spells.profiles.current),
						set = function(info,val) vexalarm.options.spells.profiles.target = val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.profiles.target end,
						},
					send_exe = {
						name = "send",
						order=3, type = "execute",
						-- disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.getList(), vexalarm.options.spells.profiles.current) or vexalarm.options.spells.profiles.target=="",
						func = function(info,val) vexalarm.options.spells.profiles.incSP.send() end,
						},
					status_send = {name = "A feedback whether the sending was successfull will be printed in your chat", type = "description", order=4},
					received_profile_load = {
						name = "received spell-profiles",
						order=10, type = "select", style = "dropdown",
						values = vexalarm.options.spells.profiles.incSP.getList(),
						set = function(self,key)
							vexalarm.options.spells.profiles.incSP.name = key
							vexalarm.options.spells.profiles.incSP.newName = vexalarm.incomeSpellProfiles[key]["name"]
							vexalarm.initialize.core(true)
							end,
						get = function() return vexalarm.options.spells.profiles.incSP.name end,
						},
					received_profile_name = {
						name = "name",
						order=11, type = "input", multiline = false,
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.incSP.getList(), vexalarm.options.spells.profiles.incSP.name),
						set = function(info,val) vexalarm.options.spells.profiles.incSP.newName = val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.profiles.incSP.newName end,
						},
					received_load_exe = {
						name = "save",
						order=12, type = "execute",
						disabled = vexalarm.options.frame.settings.getDisabled(vexalarm.options.spells.profiles.incSP.getList(), vexalarm.options.spells.profiles.incSP.name),
						func = function(info,val) vexalarm.options.spells.profiles.incSP.save() vexalarm.initialize.core(true) end,
						confirm = vexalarm_SV_spellprofiles[vexalarm.options.spells.profiles.incSP.newName]~= nil,
						confirmText = "A Spellprofile with that name allready exists. Do you want to overwrite it ?",
						},
					status = {name = vexalarm.options.spells.profiles.statusMsg["saveRe"], type = "description", order=13},
					},
				},
			}
		}
end